<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="连接名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入连接名称" />
      </el-form-item>
      <el-form-item label="端口" prop="port">
        <el-input v-model="formData.port" placeholder="请输入端口" />
      </el-form-item>
      <el-form-item label="ip" prop="ip">
        <el-input v-model="formData.ip" placeholder="请输入ip" />
      </el-form-item>
      <el-form-item label="处理器类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择处理器类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.TCP_PROCESSOR)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="重试个数" prop="reconnectNum">
        <el-input v-model="formData.reconnectNum" placeholder="请输入重试个数" />
      </el-form-item>
      <el-form-item label="重试间隔时间" prop="reconnectInterval">
        <el-input v-model="formData.reconnectInterval" placeholder="请输入重试间隔时间" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { TcpClientApi, TcpClientVO } from '@/api/logistics/tcpclient'

/** netty客户端连接 表单 */
defineOptions({ name: 'TcpClientForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  port: undefined,
  ip: undefined,
  type: undefined,
  reconnectNum: undefined,
  reconnectInterval: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TcpClientApi.getTcpClient(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TcpClientVO
    if (formType.value === 'create') {
      await TcpClientApi.createTcpClient(data)
      message.success(t('common.createSuccess'))
    } else {
      await TcpClientApi.updateTcpClient(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    port: undefined,
    ip: undefined,
    type: undefined,
    reconnectNum: undefined,
    reconnectInterval: undefined,
  }
  formRef.value?.resetFields()
}
</script>